#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire3100four4xi.py">
#<abstract4xi abstract = "fires to direction four and to distance 3100"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire3100four4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

       
# -------------------------------------------------------------------------------------------------
# SHOT2FOUR - COORDINATE SIGNS OF SHOOT2FOUR4XI: (X + ,Y - ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2four31004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False
shot2four31004xi = {
                1:'1021x-423y2895z',
                2:'1031x-1696y2381z',
                3:'1048x-1109y2698z',
                4:'1069x-379y2884z',
                5:'1093x-2848y546z',
                6:'1115x-330y2873z',
                7:'1124x-1071y2682z',
                8:'1131x-1659y2361z',
                9:'1144x-2130y1939z',
                10:'1159x-278y2861z',
                11:'1199x-1028y2667z',
                12:'1200x-223y2849z',
                13:'1231x-1616y2341z',
                14:'1238x-163y2837z',
                15:'1243x-2792y515z',
                16:'1264x-2084y1915z',
                17:'1272x-980y2651z',
                18:'1273x-100y2824z',
                19:'1305x-34y2811z',
                20:'1329x-1567y2320z',
                21:'1343x-928y2634z',
                22:'1382x-2030y1890z',
                23:'1390x-2728y485z',
                24:'1412x-870y2618z',
                25:'1425x-1512y2299z',
                26:'1479x-807y2601z',
                27:'1498x-1970y1866z',
                28:'1519x-1451y2279z',
                29:'1533x-2655y454z',
                30:'1543x-740y2584z',
                31:'157x-3009y728z',
                32:'1603x-668y2567z',
                33:'1610x-1385y2257z',
                34:'1611x-1903y1841z',
                35:'1660x-592y2550z',
                36:'1672x-2575y423z',
                37:'1698x-1312y2236z',
                38:'1713x-511y2532z',
                39:'1721x-1829y1816z',
                40:'1762x-427y2514z',
                41:'1782x-1234y2215z',
                42:'1806x-339y2496z',
                43:'1807x-2487y393z',
                44:'1827x-1749y1790z',
                45:'1846x-247y2477z',
                46:'184x-140y3091z',
                47:'1863x-1151y2193z',
                48:'1881x-152y2458z',
                49:'1911x-54y2439z',
                50:'1930x-1663y1765z',
                51:'1937x-2392y362z',
                52:'1940x-1062y2171z',
                53:'2013x-969y2148z',
                54:'2028x-1570y1740z',
                55:'2062x-2290y331z',
                56:'2080x-870y2126z',
                57:'210x-594y3035z',
                58:'2122x-1472y1714z',
                59:'2143x-767y2103z',
                60:'216x-148y3088z',
                61:'2181x-2181y300z',
                62:'2200x-660y2081z',
                63:'2210x-1368y1688z',
                64:'2252x-549y2057z',
                65:'2294x-1258y1662z',
                66:'2294x-2066y269z',
                67:'2298x-434y2034z',
                68:'2337x-316y2011z',
                69:'2371x-1144y1636z',
                70:'2371x-195y1987z',
                71:'2397x-71y1963z',
                72:'2401x-1945y239z',
                73:'2443x-1024y1609z',
                74:'2502x-1818y208z',
                75:'250x-152y3086z',
                76:'252x-610y3028z',
                77:'2589x-929y1634z',
                78:'2595x-1685y177z',
                79:'2681x-1548y146z',
                80:'2760x-1406y115z',
                81:'2830x-1260y84z',
                82:'285x-154y3082z',
                83:'2893x-1110y53z',
                84:'2948x-957y22z',
                85:'297x-623y3021z',
                86:'315x-3003y698z',
                87:'320x-152y3079z',
                88:'343x-634y3014z',
                89:'356x-147y3075z',
                90:'392x-640y3007z',
                91:'393x-138y3071z',
                92:'429x-126y3067z',
                93:'442x-644y2999z',
                94:'465x-110y3062z',
                95:'473x-2989y668z',
                96:'493x-643y2991z',
                97:'500x-91y3057z',
                98:'507x-1233y2798z',
                99:'534x-69y3052z',
                100:'546x-639y2983z',
                101:'568x-43y3047z',
                102:'583x-1230y2784z',
                103:'599x-632y2975z',
                104:'600x-14y3041z',
                105:'630x-2967y637z',
                106:'653x-620y2966z',
                107:'660x-1222y2771z',
                108:'707x-604y2957z',
                109:'737x-1210y2757z',
                110:'761x-584y2947z',
                111:'786x-2936y607z',
                112:'815x-1192y2742z',
                113:'815x-560y2937z',
                114:'827x-1751y2420z',
                115:'868x-532y2927z',
                116:'893x-1169y2728z',
                117:'920x-500y2917z',
                118:'929x-1726y2400z',
                119:'941x-2896y576z',
                120:'971x-1142y2713z',
                121:'971x-464y2906z'}
#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire3100four4xi" usage = "target function for charge31004xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire3100four4xi(queue2four, consumer_channel2four, publisher_channel2four):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE3100FOUR4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE3100FOUR4XI -  QUEUE2FOUR: ", queue2four)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE3100FOUR4XI -  CONSUMER_CHANNEL2FOUR: ", consumer_channel2four)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE3100FOUR4XI -  PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE3100FOUR4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2four.put(shot2four31004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE3100FOUR4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE3100FOUR4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE3100FOUR4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2four8shot2four31004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2four8shot2four31004xi</nack2put4xi>" 
            
        publisher_channel2four.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE3100FOUR4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE3100FOUR4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE3100FOUR4XI - RETURNING QUEUE OBJECT QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi())  
        # 
            
    return queue2four    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire3100four4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                                    